window.androidObj = function AndroidClass(){};

function PrimisAppApi() {
    var ref = this;

    //Array of objects that ware sent to app, holding the reference to a callback func from web
    var toAppCbArray = [];

    //Array of objects that ware sent from app for returning callback result to the app
    var fromAppCbArray = [];

    var index = 0;

    this.receiveFromApp;
    this.callbackFromApp;

    this.sendToApp = function (apiObj) {
         var data = JSON.stringify(apiObj);
         if(window.primisLog)window.primisLog('[[AppSDKApi]] jscode sendToApp: ' + data);
         window.androidObj.sendToApp(data);
    };

    this.callbackToApp = function (apiObj) {
         var obj = {};
         obj.id = apiObj.id;
         obj.index = apiObj.index;
         obj.value = apiObj.value;
         obj.data = apiObj.data;
         var data = JSON.stringify(obj);
         window.androidObj.callbackToApp(data);
    };

    this.callbackToWebview = function(message) {
        var data = JSON.parse(message);
        if(this.callbackFromApp)this.callbackFromApp(data);
    };

    this.sendToWebview = function(message) {
//        console.log(message)
        var data = JSON.parse(message);
        if(this.receiveFromApp)this.receiveFromApp(data);
    };

    this.buildTag = function(baseURL, tagStr) {
        var random = Math.floor(Math.random() * 100000);
        var script = document.createElement('script');
        script.type = 'text/javascript';
        script.onerror = function(e) {
            var obj = new AppApiObj();
            obj.id = 'scriptLoadError';
            obj.type = 'report';
            obj.value = e;
            ref.sendToApp(obj);
        }
        script.onload = function() {
            var obj = new AppApiObj();
            obj.id = 'scriptLoadSuccess';
            obj.type = 'report';
            ref.sendToApp(obj);
        }
        script.src = baseURL + random + tagStr;
        console.log(script.src);
//        script.src = 'https://live.primis.tech/live/liveView.php?cbuster=' + random + tagStr;
//        script.src = 'https://123.primis-dev.tech/live/liveView.php?cbuster=' + random + tagStr;
        document.body.appendChild(script);
    };

    function AppApiObj() {
        this.id = '';              //The command or request name
        this.type = '';            //request, command, callback or report
        this.data = [];            //Array of "AppApiObj" objects
        this.value = null;         //Single value of primitive - string, float or Int
        this.callback = undefined; //Callback function
    };

    this.getIllegalPlacementObj = function() {
        var obj = new AppApiObj();
        obj.id = 'illegalPlacementEvent';
        obj.type = 'report';
        obj.value = 'illegalPlacementEvent';
        obj.data =
            [{"id":"errValue","type":"","data":[],"value":'Illegal placement event was fired'}];
        return obj;
    };

    window.top.addEventListener("illegalPlacementEvent", function(e) {
        var obj = ref.getIllegalPlacementObj();
        ref.sendToApp(obj);
    });

    function getObjByIndex(array, index) {
        return array.filter(function(a) { return a.index == index })[0]
    };
}

var primisAppApi = new PrimisAppApi();